#include <bits/stdc++.h>

using namespace std;

vector<int> the_set = {0, 1, 2};    // init with all elements of interest
vector<int> permutation;            // must be empty when the search starts
unordered_set<int> chosen;          // must be empty when the search starts
void search() {
    if(permutation.size() == the_set.size()) {
        cout << "a permutation:";
        for(auto x : permutation) cout << " " << x;
        cout << endl;
        return;
    }

    // in position permutation.size(), put any element that has not been already chosen
    for(auto x : the_set) {
        if(chosen.find(x) != chosen.end()) continue;
        chosen.insert(x);
        permutation.push_back(x);
        search();
        chosen.erase(x);
        permutation.pop_back();
    }
}

int main() {
    search();
    
    cout << endl << endl;

    // same stuff, but using the standard library
    {
        vector<int> permutation = the_set;
        do{
            cout << "a permutation:";
            for(auto x : permutation) cout << " " << x;
            cout << endl;
        }while(next_permutation(permutation.begin(), permutation.end()));
    }
    
    return 0;
}
